`include "cypress.v"

module WolframCA (en, rst, clk, dout, q);
			 
	output [7:0] dout;
    output reg q;
	input en, rst, clk;	 

	reg [7:0] ca_reg;
	reg [7:0] ca_new;
	reg [7:0] tmp_new;
	reg temp,tmp;
	
	parameter rule = 8'd30;
	
	assign dout = ca_reg;

  	always @ (posedge clk)
    	begin
      	if (rst)
        begin
        ca_reg <= 8'b00000000;
	    temp <= 1'b0;
        q <= 1'b0;
        end
      	else if (en)
        begin
            ca_reg <= ca_new;
			temp <= 1'b1;
			tmp <= 1'b1 & ~temp;
            if (ca_reg == rule) q <= 1'b1;
			else q <= 1'b0;
        end
    end

  	always @(posedge clk)
    	begin
  
      	case({ca_reg[7],ca_reg[0],ca_reg[1]})
        0:tmp_new[0] = rule>>0;
        1:tmp_new[0] = rule>>1;
        2:tmp_new[0] = rule>>2;
        3:tmp_new[0] = rule>>3;
        4:tmp_new[0] = rule>>4;
        5:tmp_new[0] = rule>>5;
        6:tmp_new[0] = rule>>6;
        7:tmp_new[0] = rule>>7;
		endcase

      	case({ca_reg[0],ca_reg[1],ca_reg[2]})
        0:tmp_new[1] = rule>>0;
        1:tmp_new[1] = rule>>1;
        2:tmp_new[1] = rule>>2;
        3:tmp_new[1] = rule>>3;
        4:tmp_new[1] = rule>>4;
        5:tmp_new[1] = rule>>5;
        6:tmp_new[1] = rule>>6;
        7:tmp_new[1] = rule>>7;
		endcase

    	case({ca_reg[1],ca_reg[2],ca_reg[3]})
        0:tmp_new[2] = rule>>0;
        1:tmp_new[2] = rule>>1;
        2:tmp_new[2] = rule>>2;
        3:tmp_new[2] = rule>>3;
        4:tmp_new[2] = rule>>4;
        5:tmp_new[2] = rule>>5;
        6:tmp_new[2] = rule>>6;
        7:tmp_new[2] = rule>>7;
		endcase

      	case({ca_reg[2],ca_reg[3],ca_reg[4]})
        0:tmp_new[3] = rule>>0;
        1:tmp_new[3] = rule>>1;
        2:tmp_new[3] = rule>>2;
        3:tmp_new[3] = rule>>3;
        4:tmp_new[3] = rule>>4;
        5:tmp_new[3] = rule>>5;
        6:tmp_new[3] = rule>>6;
        7:tmp_new[3] = rule>>7;
		endcase

      	case({ca_reg[3],ca_reg[4],ca_reg[5]})
        0:tmp_new[4] = rule>>0;
        1:tmp_new[4] = rule>>1;
        2:tmp_new[4] = rule>>2;
        3:tmp_new[4] = rule>>3;
        4:tmp_new[4] = rule>>4;
        5:tmp_new[4] = rule>>5;
        6:tmp_new[4] = rule>>6;
        7:tmp_new[4] = rule>>7;
		endcase

		case({ca_reg[4],ca_reg[5],ca_reg[6]})
        0:tmp_new[5] = rule>>0;
        1:tmp_new[5] = rule>>1;
        2:tmp_new[5] = rule>>2;
        3:tmp_new[5] = rule>>3;
        4:tmp_new[5] = rule>>4;
        5:tmp_new[5] = rule>>5;
        6:tmp_new[5] = rule>>6;
        7:tmp_new[5] = rule>>7;
		endcase

		case({ca_reg[5],ca_reg[6],ca_reg[7]})
        0:tmp_new[6] = rule>>0;
        1:tmp_new[6] = rule>>1;
        2:tmp_new[6] = rule>>2;
        3:tmp_new[6] = rule>>3;
        4:tmp_new[6] = rule>>4;
        5:tmp_new[6] = rule>>5;
        6:tmp_new[6] = rule>>6;
        7:tmp_new[6] = rule>>7;
		endcase

      	case({ca_reg[6],ca_reg[7],ca_reg[0]})
        0:tmp_new[7] = rule>>0;
        1:tmp_new[7] = rule>>1;
        2:tmp_new[7] = rule>>2;
        3:tmp_new[7] = rule>>3;
        4:tmp_new[7] = rule>>4;
        5:tmp_new[7] = rule>>5;
        6:tmp_new[7] = rule>>6;
        7:tmp_new[7] = rule>>7;
		endcase	  

     	if (tmp) ca_new = rule;
		else ca_new = tmp_new;           

    end
	
endmodule